#ifndef __SUPPORT_H__
#define __SUPPORT_H__

#define MyFree(__x)			support_free((__x))
#define MyMalloc(__x)		support_malloc((__x))
#define MyRealloc(__x, __y)	support_realloc((__x), (__y))
#define MyStrdup(__x)		support_strdup((__x))

#define BCOPY(__x, __y, __z) memmove((__y), (__x), (__z))
#define BCMP(__x, __y, __z)	memcmp((__x), (__y), (__z))
#define BZERO(__x, __y)		memset((__x), 0, (__y))

#ifdef USE_SUPPORT_POLL

struct pollfd
{
	int		fd;
	int		events;
	int		revents;
};

#define POLLIN	0x0001
#define POLLOUT	0x0004

#define poll support_poll

#endif

int ircd_getpagesize(void);
void support_free(void *ptr);
void support_free_dbg(void *ptr, char *filename, int lineno);
void *support_malloc(size_t len);
void *support_realloc(void *ptr, size_t len);
char *support_strdup(char *string);
char *support_strncpy(char *dest, char *src, int len);
char *support_stristr(char *str1, char *str2);
char *support_ctime(int thetime);
char *support_strerror(int errnum);
#ifdef USE_SUPPORT_POLL
int support_poll(struct pollfd *pfd, int npfds, int timeout);
#endif

#endif
